;82 port by Ilya Winham and additional coding by Eric Piel
;83 version by Harper Maddox

#INCLUDE "Ti82.h"

NUMROWS	= 41	; number of rows
NUMCOLS	= 50	; number of columns
STARTSPOT = 1927 ; NUMCOLS * 38	+ 48

mapstart	= TEXT_MEM	;2
yourspot	= TEXT_MEM+2	;2
temp		= TEXT_MEM+4	;2 or 1, it depends
chspot		= TEXT_MEM+6	;2
chprev		= TEXT_MEM+8	;1
dir		= TEXT_MEM+9	;1	; storage location... It is a good place to
time		= TEXT_MEM+10	;1	; store variables
tim2		= TEXT_MEM+11	;1
chleft		= TEXT_MEM+12	;1
level		= TEXT_MEM+13	;1
totlt		= TEXT_MEM+14	;1
chcoop		= TEXT_MEM+15	;1
string		= TEXT_MEM+16	;6

.org START_ADDR
.db "Chicken Shoot v1.2",0


prog_start:
	TEXT_START
	ld	hl,TEXT_MEM
	ld	(hl),0
	ld	de,TEXT_MEM+1
	ld	bc,22
	ldir
 call BUFCLR		; clear	the graph buffer
 ld hl,cstitl		; load the label for the picture into the data pointer
 ld de,GRAPH_MEM	; starting memory location for writing to graph	buffer
 ld bc,240		; # of bytes to	paint
 ldir			; load them together!

 ld a,56		; X-coordinate for sprite
 ld e,32		; Y-coordinate for sprite
 ld hl,manl1		; pointer to sprite
 call sprite		; draw sprite (top of man)
 ld a,56
 ld e,40
 ld hl,manl2
 call sprite		; bottom of man
 ld a,24
 ld e,36
 ld hl,chicken		; draw the chicken
 call sprite
 ROM_CALL(DISP_GRAPH)	; paint the graph buffer with the sprite and title

	ld	b,4
introlop:
	push	bc
	call	revscreen
	pop	bc
	djnz	introlop

 ld hl,22*256+11	; 22 rows down, 11 columns across
 ld (CURSOR_X),hl	; put that into text pointer
 ld hl,hm		; put	the pointer to the "hm"	string into hl
 ROM_CALL(D_ZM_STR)	; display the text frpm the string stored in hl


;-------A cool routine devised by Myself and Andrew Ungvarsky------------
; Displays a flashing "Press 2nd"

;	xor	a		; initialize reverse variable
;	ld	(temp),a
introwait:
	ld	b,20
loop:
	halt
	halt
	ld	a,0ffh		; reset	keyport
	out	(1),a		; necessary code
	ld	a,10111101b	; enable row with clear
	out	(1),a		; necessary code
	in	a,(1)		; get #	of any key pressed->a
	bit	6,a		; clear???
	ret	z		; return to what called the program... The OS so it quits
	bit	5,a
	jr	z,level0	; If key="2nd" then start the game
	djnz	loop

	ld	hl,temp
	ld	a,(hl)
	inc	a
	ld	(hl),a
	rra			; is it an odd
	jr	c,norm		; goto "norm" if temp isnt equal to 2
	ld	(hl),0
	SET	3,(IY+05)	; Flash... inverse text is on
norm:
	ld	hl,0306h	; Home screen text starts at (6,3)
	ld	(CURSOR_ROW),hl
	ld	hl,secnd
	ROM_CALL(D_ZT_STR)	; display the "secnd" string
	RES	3,(IY+05)	; turn Text Inverse off
	jr	introwait	; return back to the intro loop

level0:
 xor	a
 ld	(level),a
lvup:
 ld	a,(level)		; increase the level by	1
 inc	a
 cp	9
 jr	z,level0

 ld	(level),a
 ld	(chleft),a	 	; level = number of chickens to kill per level

 ld b,5				; B=number of times to repeat loop
lvloop:
 push bc			; Maintain bc by pushing it to the stack
 call BUFCLR			; clear graph buffer
title2:
 ld hl,cstitl
 ld de,GRAPH_MEM
 ld bc,240
 ldir
 ROM_CALL(DISP_GRAPH)
 pop bc				; restore bc from stack
 ld l,3
 ld a,6
 sub b
 ld	h,a
 ld (CURSOR_ROW),hl
 ld hl,letl
 ROM_CALL(D_ZT_STR)	; gimme a "l"

 ld a,2
 add a,b
 ld	l,a
 ld a,7
 sub b
 ld	h,a
 ld (CURSOR_ROW),hl
 ld hl,lete
 ROM_CALL(D_ZT_STR)	; gimme an "e"

 ld	a,2
 add	a,b
 ld	l,a
 ld	h,7
 ld	(CURSOR_ROW),hl
 ld	hl,letv
 ROM_CALL(D_ZT_STR)	; how about a "v"

 ld a,2
 add a,b
 ld	l,a
 ld a,7
 add a,b
 ld	h,a
 ld (CURSOR_ROW),hl
 ld hl,lete
 ROM_CALL(D_ZT_STR)	; "e"

 ld l,3
 ld a,8
 add a,b
 ld	h,a
 ld (CURSOR_ROW),hl
 ld hl,letl
 ROM_CALL(D_ZT_STR)	; "l" ... What does it spell ... level!
 call dl
 call dl
 call dl
 djnz lvloop

	ld	hl,0305h
	ld	(CURSOR_ROW),hl
	ld	a,(level)
	ld	l,a
	ld	h,0
	ROM_CALL(D_HL_DECI)		; which level?

 ld hl,55*256+0
 ld (CURSOR_X),hl
 ld hl,tastr
 ROM_CALL(D_ZM_STR)
 ld a,(level)
 ld b,a
 xor	a
talop:		;a=30*b (level n)
 add a,30
 djnz talop
 ld (totlt),a
 call dispa
 ld hl,55*256+55
 ld (CURSOR_X),hl
 ld hl,cstr
 ROM_CALL(D_ZM_STR)
 ld hl,hiscs
 ld a,(level)
 ld e,a
 ld d,0
 add hl,de
 ld a,(hl)
 call dispa
beglp:
 call GET_KEY
 cp 09h	  ;enter key
 jp nz,beglp

 	xor	a
 	ld	(temp),a

stgame:
	xor	a
	ld	(time),a
	ld	(tim2),a
	ld	(dir),a
	call	nuchick
	ld	hl,map+STARTSPOT-204
	ld	(mapstart),hl		; mapstart on screen
	ld	hl,map+STARTSPOT	; offset where you start (see STARTSPOT)
	ld	(yourspot),hl
	call	drawmap
	call	dl
 ;	xor	a
	jr	keyloop			; keyloop is really gameloop :)

moveleft:
	ld	a,3
	ld	de,-1
	jr	moveEnd
moveright:
	ld	a,1
	ld	de,1
	jr	moveEnd
moveup:
	xor	a
	ld	de,-NUMCOLS
	jr	moveEnd
movedown:
	ld	a,2
	ld	de,NUMCOLS
moveEnd:
	ld (dir),a
	ld hl,(yourspot)
	add hl,de
	ld a,(hl)
	cp 3
	ret nc
	ld (yourspot),hl
	ld hl,(mapstart)
	add hl,de
	ld (mapstart),hl
	ret

keyloop:
 call dl
	ld	c,1
	ld	a,0ffh		;reset keyport
	out (c),a		;necessary code
	dec	a	;ld a,0FEh	; Check	the arrow keys
	out	(c),a
 	in	a,(c)
	cp 254
	CALL	z,movedown
	cp 253
	CALL	z,moveleft
	cp 251
	CALL	z,moveright
	cp 247
	CALL	z,moveup
 ld a,$BF	   ; Check 2nd and more
 out (c),a
 in a,(c)
 bit 5,a
 call z,shoot
 cp 191
 call z,pause
 ld a,(temp)
 cp 187		;????????
 jp z,lvup

 ld a,0fdh			;enable	row with clear
 out (1),a			;necessary code
 in a,(1)			;get # of any key pressed->a
 cp 191				;clear???
 jp z,die

	call	drawmap
;Draw the man's sprite with the good direction
	ld	a,(dir)
	and	a	;just reset carry
	rla
	rla
	rla
	rla	;a*16
	ld	e,a
	ld	d,0
	ld	hl,SprMan
	add	hl,de
	push	af
	push	hl
	ld	a,32
	ld	e,28
	call	sprite
	pop	hl
	pop	af
	ld	de,8
	add	hl,de	
	ld	a,32
	ld	e,36
	call	sprite

 ld a,(tim2)
 inc a
 ld (tim2),a
 cp 6
 jr	nz,NoIncTime
inctim:
	xor	a
	ld	(tim2),a
	ld	hl,time
	inc	(hl)
 ld a,(chcoop)
 or	a
 jr	z,cop1
 dec	a
 jr	z,cop2
 dec	a
 jr	z,cop3
cop4:
 ld a,90
 ld e,33
 jr cop
cop1:
 ld a,76
 ld e,23
 jr cop
cop2:
 ld a,90
 ld e,23
 jr cop
cop3:
 ld a,76
 ld e,33
cop:
 ld	hl,chicken
 call	sprite
 call	dl
NoIncTime:
 ROM_CALL(DISP_GRAPH)
 ld a,(totlt)
 ld b,a
 ld a,(time)
 cp b
 jp z,die
 ld hl,55*256+81
 ld (CURSOR_X),hl
 call dispa
 ld hl,8*256+83
 ld (CURSOR_X),hl
 ld a,(chleft)
 call dispa
	halt
	halt
	halt

rand:
 ld hl,(chspot)
 ld	b,h
 ld	c,l
 ld a,r
 AND 3
 jr z,clf
 dec	a
 jr z,crt
 dec	a
 jr z,cup
cdn:
	ld	de,NUMCOLS
	jr	cMoveEnd
clf:
	ld	de,-1
	jr	cMoveEnd
crt:
	ld	de,1
	jr	cMoveEnd
cup:
	ld	de,-NUMCOLS
cMoveEnd:
	add	hl,de
	ld	a,(hl)
	cp	3
	jp	nc,keyloop
	push	af
	ld a,(chprev)
	ld (bc),a
	pop	af
	ld	(chprev),a
	ld	(hl),10
	ld	(chspot),hl
	jp	keyloop



drawmap:
	call	BUFCLR
	ld	hl,csbg
	ld	de,GRAPH_MEM
	ld	bc,64*3
DMLoop:
	push	hl
	ld	hl,9
	add	hl,de
	ex	de,hl
	pop	hl
	ldi
	ldi
	ldi
	jp	pe,DMLoop
	ld	hl,(mapstart)
	ld	de,GRAPH_MEM

draw_loop:
	ld b,8
draw2:
	push	bc		; b = screen sizes for loops
	ld	b,9
draw_loop2:
	ld	a,(hl)
	push	hl
	push	de
	ld	de,map
	call	CP_HL_DE
	jr	c,DL2NoDraw
	ld	de,mapEnd
	call	CP_HL_DE
	jr	nc,DL2NoDraw
	or	a
	jr	z,DL2NoDraw
	rla			;carry has been reset
	rla
	rla			;a*8
	ld	hl,SprItem-8
	ld	e,a
	ld	d,0
	add	hl,de
	pop	de
drawblock:
	push	de
	push	bc
	ld	b,8		; my GREAT sprite routine
block_loop:
	push	hl
	ld	a,(hl)
	ld	(de),a
	ld	hl,12
	add	hl,de
	ex	de,hl
	pop	hl
	inc	hl
	djnz	block_loop
	pop	bc
DL2NoDraw:
	pop	de
	pop	hl
	inc	hl
	inc	de
	djnz	draw_loop2
	push de
	ld	de,NUMCOLS-9
	add	hl,de
	pop de
	push hl
	ld hl,87		; 87 is the number to get to the
	add hl,de		; next row on the screen
	ex de,hl
	pop hl
	pop bc
	djnz draw2
	ret

shoot:
 ld a,(dir)
 ld b,4
 or	a
 jr	z,sup
 dec	a
 jp	z,srt
 dec	a
 jp	z,sdn
slf:
 ld a,24
 ld (temp),a
 ld hl,(yourspot)
s1:
 dec hl
 ld de,(chspot)
 call CP_HL_DE
 jp z,kill
 push hl
 push bc
 ld e,31
 ld hl,shot
 ld a,(temp)
 call sprite
 ROM_CALL(DISP_GRAPH)
 ld e,31
 ld a,(temp)
 ld hl,shot
 call CLRSPR
 ld a,(temp)
 sub 8
 ld (temp),a
 pop bc
 call dl
 pop hl
 djnz s1
 ret

sup:
 ld a,26
 ld (temp),a
 ld hl,(yourspot)
s0:
 ld	de,-NUMCOLS
 add	hl,de
 ld	de,(chspot)
 call CP_HL_DE
 jp z,kill
 push hl
 push bc
 ld a,(temp)
 ld e,a
 ld a,32
 ld hl,shot
 call sprite
 ROM_CALL(DISP_GRAPH)
 ld a,(temp)
 ld e,a
 sub 8
 ld (temp),a
 ld a,32
 ld hl,shot
 call CLRSPR
 pop bc
 call dl
 pop hl
 djnz s0
 ret

srt:
 ld a,40
 ld (temp),a
 ld hl,(yourspot)
s2:
 inc hl
 ld de,(chspot)
 call CP_HL_DE
 jp z,kill
 push hl
 push bc
 ld e,31
 ld a,(temp)
 ld hl,shot
 call sprite
 ROM_CALL(DISP_GRAPH)
 ld e,31
 ld a,(temp)
 ld hl,shot
 call CLRSPR
 ld a,(temp)
 add a,8
 ld (temp),a
 pop bc
 call dl
 pop hl
 djnz s2
 ret

sdn:
 ld a,32
 ld (temp),a
 ld hl,(yourspot)
s3:
 ld de,NUMCOLS
 add hl,de
 ld de,(chspot)
 call CP_HL_DE
 jp z,kill
 push hl
 push bc
 ld a,(temp)
 ld e,a
 ld a,32
 ld hl,shot
 call sprite
 ROM_CALL(DISP_GRAPH)
 ld a,(temp)
 ld e,a
 add a,8
 ld (temp),a
 ld a,32
 ld hl,shot
 call CLRSPR
 pop bc
 call dl
 pop hl
 djnz s3
 ret

kill:
 call	revscreen
 call	revscreen
 ld	a,(chprev)
 ld	hl,(chspot)
 ld	(hl),a
 ld	hl,chleft
 dec 	(hl)
 jr	z,win
nuchick:
 ld a,r
 AND 3
 ld (chcoop),a
 or	a
 jr z,stmap1
 dec	a
 jr z,stmap2
 dec	a
 jr z,stmap3
stmap4:
 ld	hl,1389+map
 jr	stmapEnd
stmap1:
 ld	hl,353+map
 jr	stmapEnd
stmap2:
 ld	hl,396+map
 jr	stmapEnd
stmap3:
 ld	hl,1813+map
stmapEnd:
 ld	(chspot),hl
 ld	a,(hl)
 ld	(chprev),a
 ret

win:
 call BUFCLR
 ld hl,cstitl
 ld de,GRAPH_MEM
 ld bc,240
 ldir
 ROM_CALL(DISP_GRAPH)

 ld hl,24*256+5
 ld (CURSOR_X),hl
 ld hl,win1
 ROM_CALL(D_ZM_STR)
 ld hl,0205h
 ld (CURSOR_ROW),hl
 ld hl,tstr
 ROM_CALL(D_ZT_STR)
 ld a,(time)
 ld l,a
 ld h,0
 ROM_CALL(D_HL_DECI)

 ld hl,hiscs
 ld de,(level)		;just for e
 ld d,0
 add hl,de
 ld a,(hl)
 ld bc,(time - 1)	;just for b
 cp b
 jp nc,newhi
winlp:
 call GET_KEY
 cp 09h	  ;enter key
 jp nz,winlp
 ld a,187
 ld (temp),a
 ret

newhi:
 ld a,b
 ld (hl),a
 ld hl,0007h
 ld (CURSOR_ROW),hl
 ld hl,nwhi
 ROM_CALL(D_ZT_STR)
 jr winlp

pause:
 call BUFCLR
 ld hl,cstitl
 ld de,GRAPH_MEM
 ld bc,240
 ldir
 ROM_CALL(DISP_GRAPH)
 SET 3,(IY+05)
 ld hl,0403h
 ld (CURSOR_ROW),hl
 ld hl,paused
 ROM_CALL(D_ZT_STR)
 RES 3,(IY+05)
pause2:
 halt
 call GET_KEY
 cp 09h
 jp nz,pause2
 ret

die:
 ld a,(chprev)
 ld hl,(chspot)
 ld (hl),a

 call BUFCLR
 ld hl,cstitl
 ld de,GRAPH_MEM
 ld bc,240
 ldir
 ROM_CALL(DISP_GRAPH)

 ld hl,0404h
 ld (CURSOR_ROW),hl
 ld hl,gmover
 ROM_CALL(D_ZT_STR)
die2:
 call GET_KEY
 cp 09h
 jp nz,die2
 ret

dl:
	push	bc
	ld	b,9
spd:
	halt
	djnz	spd
	pop	bc
 ret

revscreen:
	ld	hl,GRAPH_MEM
	ld	bc,768
rloop:
	ld	a,(hl)
	cpl
	ld	(hl),a
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,rloop
	ROM_CALL(DISP_GRAPH)
	call	dl
	call	dl
	ret
dispa:
	ld	l,a
	ld	h,0
disphl:
	ld de,string+5
	xor a
;	ld (de),a	;not needed because it's always 0
Repeat:
	call UNPACK_HL
	add a,'0'
	dec de
	ld (de),a
	ld a,h
	or l
	jr nz,Repeat
	ex de,hl
	ROM_CALL(D_ZM_STR)
	ret

BUFCLR:
	ld hl,GRAPH_MEM
	ld de,GRAPH_MEM+1
	ld bc,768
	ld (hl),0
	ldir
	ret


; SPRITE 
;+----------------------------------------------------------------------------+
; Blit	or erase sprite	 a=x, e=y, hl=sprite address			      
;+----------------------------------------------------------------------------+
sprite:

	push	hl		; Save sprite address

;	Calculate the address in graphbuf   

	ld	hl,0		; Do y*12
	ld	d,0
	add	hl,de
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl

	ld	d,0		; Do x/8
	ld	e,a
	srl	e
	srl	e
	srl	e
	add	hl,de

	ld	de,$88B8
	add	hl,de		; Add address to graphbuf

	ld	b,00000111b	; Get the remainder of x/8
	and	b

;	Aligned	sprite blit starts here	  

ALIGN:				; Blit an aligned sprite to graphbuf
	pop	de		; de->sprite
	ld	b,8
ALOP1:	ld	a,(de)
	or	(hl)		; xor=erase/blit
	ld	(hl),a
	inc	de
	push	bc
	ld	bc,12
	add	hl,bc
	pop	bc
	djnz	ALOP1

DONE1:
	ret

CLRSPR:
	push	hl		; Save sprite address

;	Calculate the address in graphbuf   

	ld	hl,0		; Do y*12
	ld	d,0
	add	hl,de
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl

	ld	d,0		; Do x/8
	ld	e,a
	srl	e
	srl	e
	srl	e
	add	hl,de

	ld	de,$88B8
	add	hl,de		; Add address to graphbuf

	ld	b,00000111b	; Get the remainder of x/8
	and	b
	or	a		; Is this sprite aligned to 8*n,y?
	jp	z,ALIGN2


;	Non aligned sprite erase starts	here   

	pop	ix		; ix->sprite
	ld	d,a		; d=how	many bits to shift each	line

	ld	e,8		; Line loop
LILOP2:	ld	b,(ix+0)	; Get sprite data

	ld	c,0		; Shift	loop
	push	de
SHLOP2:	srl	b
	rr	c
	dec	d
	jp	nz,SHLOP2
	pop	de

	ld	a,b		; Write	line to	graphbuf
	cpl
	and	(hl)
	ld	(hl),a
	inc	hl
	ld	a,c
	cpl
	and	(hl)
	ld	(hl),a

	ld	bc,11		; Calculate next line address
	add	hl,bc
	inc	ix		; Inc spritepointer

	dec	e
	jp	nz,LILOP2	; Next line

	jp	DONE5


;	Aligned	sprite erase starts here   

ALIGN2:				; Erase	an aligned sprite in graphbuf
	pop	de		; de->sprite
	ld	b,8
ALOP2:	ld	a,(de)
	cpl
	and	(hl)
	ld	(hl),a
	inc	de
	push	bc
	ld	bc,12
	add	hl,bc
	pop	bc
	djnz	ALOP2

DONE5:
	ret
;_ SPRITE _

.include csgrfx.asm

hiscs: .db 255,255,255,255,255,255,255,255
secnd:	.db "Press  2nd",0
win1: .db "Yew Plum Kilt Them Chikins",0
tstr: .db "Time: ",0
hm: .db	"By: Harper M./Ilya W.",0
letl: .db "l",0
lete: .db "e",0
letv: .db "v",0
cstr: .db "Record: ",0
tastr: .db "Time Left: ",0
nwhi: .db "New High Score!",0
paused:	.db "*Paused*",0
gmover:	.db "Game Over",0

.end


